#!/bin/sh

# TEST: Branches: b0,b1=ro,b2=ro
# TEST: open(D) where D is
# TEST:  a directory in b0
# TEST:  nonexistent in b1
# TEST:  a directory in b0

source scaffold

function files {
cat <<FILES
d $LOWER_DIR
d $LOWER_DIR/b0
d $LOWER_DIR/b1
d $LOWER_DIR/b2
FILES
}

function beforefiles {
cat <<FILES
d $LOWER_DIR/b0/a
d $LOWER_DIR/b2/a

f $LOWER_DIR/b0/b
f $LOWER_DIR/b1/c
f $LOWER_DIR/b2/d

f $LOWER_DIR/b0/e
f $LOWER_DIR/b1/e
f $LOWER_DIR/b2/e
FILES
}

function afterfiles {
	beforefiles
}

( files ; beforefiles) | create_hierarchy

mount_union "" $LOWER_DIR/b0 $LOWER_DIR/b1=ro $LOWER_DIR/b2=ro

checktype $MOUNTPOINT/a 'd'
/bin/ls $MOUNTPOINT/a >/dev/null

echo "$LOWER_DIR/b0/b" |diff /mnt/unionfs/b -
echo "$LOWER_DIR/b1/c" |diff /mnt/unionfs/c -
echo "$LOWER_DIR/b2/d" |diff /mnt/unionfs/d -

echo "$LOWER_DIR/b0/e" |diff /mnt/unionfs/e -

unmount_union

( files ; afterfiles )  | check_hierarchy $LOWER_DIR

complete_test
